const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Invoices_saasDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const invoices_saas = await db.invoices_saas.create(
      {
        id: data.id || undefined,

        invoice_number: data.invoice_number || null,
        amount_mad: data.amount_mad || null,
        status: data.status || null,
        issued_at: data.issued_at || null,
        pdf_url: data.pdf_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await invoices_saas.setTenant(data.tenant || null, {
      transaction,
    });

    await invoices_saas.setSubscription(data.subscription || null, {
      transaction,
    });

    await invoices_saas.setAgences(data.agences || null, {
      transaction,
    });

    return invoices_saas;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const invoices_saasData = data.map((item, index) => ({
      id: item.id || undefined,

      invoice_number: item.invoice_number || null,
      amount_mad: item.amount_mad || null,
      status: item.status || null,
      issued_at: item.issued_at || null,
      pdf_url: item.pdf_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const invoices_saas = await db.invoices_saas.bulkCreate(invoices_saasData, {
      transaction,
    });

    // For each item created, replace relation files

    return invoices_saas;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const invoices_saas = await db.invoices_saas.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.invoice_number !== undefined)
      updatePayload.invoice_number = data.invoice_number;

    if (data.amount_mad !== undefined)
      updatePayload.amount_mad = data.amount_mad;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.issued_at !== undefined) updatePayload.issued_at = data.issued_at;

    if (data.pdf_url !== undefined) updatePayload.pdf_url = data.pdf_url;

    updatePayload.updatedById = currentUser.id;

    await invoices_saas.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await invoices_saas.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.subscription !== undefined) {
      await invoices_saas.setSubscription(
        data.subscription,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await invoices_saas.setAgences(
        data.agences,

        { transaction },
      );
    }

    return invoices_saas;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const invoices_saas = await db.invoices_saas.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of invoices_saas) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of invoices_saas) {
        await record.destroy({ transaction });
      }
    });

    return invoices_saas;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const invoices_saas = await db.invoices_saas.findByPk(id, options);

    await invoices_saas.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await invoices_saas.destroy({
      transaction,
    });

    return invoices_saas;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const invoices_saas = await db.invoices_saas.findOne(
      { where },
      { transaction },
    );

    if (!invoices_saas) {
      return invoices_saas;
    }

    const output = invoices_saas.get({ plain: true });

    output.tenant = await invoices_saas.getTenant({
      transaction,
    });

    output.subscription = await invoices_saas.getSubscription({
      transaction,
    });

    output.agences = await invoices_saas.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.subscriptions,
        as: 'subscription',

        where: filter.subscription
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.subscription
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  provider_customer_id: {
                    [Op.or]: filter.subscription
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.invoice_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'invoices_saas',
            'invoice_number',
            filter.invoice_number,
          ),
        };
      }

      if (filter.pdf_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('invoices_saas', 'pdf_url', filter.pdf_url),
        };
      }

      if (filter.amount_madRange) {
        const [start, end] = filter.amount_madRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount_mad: {
              ...where.amount_mad,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount_mad: {
              ...where.amount_mad,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.issued_atRange) {
        const [start, end] = filter.issued_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            issued_at: {
              ...where.issued_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            issued_at: {
              ...where.issued_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.invoices_saas.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('invoices_saas', 'invoice_number', query),
        ],
      };
    }

    const records = await db.invoices_saas.findAll({
      attributes: ['id', 'invoice_number'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['invoice_number', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.invoice_number,
    }));
  }
};
